import {Drawable} from "./drawable"
import {Point} from "./point"
import {getRandomInt} from "./utils"

export class Arrow extends Drawable{

	constructor(origin, length, angle) {

		super();

		this.origin = origin;
		this.length = length;
		this.angle = angle || 0;
		this.side = 1;
		this.A = new Point(0, 0);
		this.B = new Point(this.A.x + this.side, this.A.y)
		this.C = new Point(this.A.x + this.side / 2, this.A.y + this.side * Math.sin(Math.PI/3))
	}

	draw() {

		push();
		translate(this.origin.x, this.origin.y);
		rotate(this.angle);
		push();
			translate(this.length, this.side / 2);
			rotate(-90);
			triangle(this.A.x, this.A.y, this.B.x, this.B.y, this.C.x, this.C.y);
		pop();
		strokeWeight(this.side);
		line(0, 0, this.length, 0);
		pop();

	}

	update() {

		this.angle+= 0.02;
		if (this.angle > 360) {
			this.angle = 0;
		}

		this.origin.x += getRandomInt(-0, 0);
		this.origin.y += getRandomInt(-0, 0);

		if (this.origin.x > 800 ) {

			this.origin.x = 0;
		}

		if (this.origin.x < 0 ) {

			this.origin.x = 800;
		}

		if (this.origin.y > 800 ) {

			this.origin.y = 0;
		}

		if (this.origin.y < 0 ) {

			this.origin.y = 800;
		}
	}
}