import {Drawable} from "./drawable"
import {getRandomInt} from "./utils"

export class Circle {

	constructor(manager, x=null, y=null, r=null, r2=null) {

		this.x = x || getRandomInt(0, 800);
		this.y = y || getRandomInt(800, 1000);
		this.r = r || getRandomInt(70, 200) + getRandomInt(-1, 1) * getRandomInt(0, 20);
		this.lifeSpan = getRandomInt(0, 20);
		this.maxRadius = this.r;


		this.delta = getRandomInt(0.1, 1);

		this.vx = getRandomInt(-2, 2);
		this.vy = getRandomInt(0, 10);

		this.manager = manager;

		let red = getRandomInt(0, 255);
		let green = getRandomInt(0, 255);
		let blue = getRandomInt(0, 255);


		this.color = color(red, green, blue);
	}

	update() {

		if (this.r > this.maxRadius) {
  			this.delta = -this.delta;

  		} else if (this.r < 20) {
  			this.delta = -this.delta;
  			this.lifeSpan--;
  		}

  		this.r+=this.delta;

  		this.x += this.vx;
  		this.y -= this.vy;


  		if (this.x > 1000 - this.r) {

  			this.apoptosis();
  		}

  		if (this.y > 10000) {

  			this.apoptosis();
  		}

  		if (this.y < -100) {

  			this.apoptosis();
  		}

  		

  		if (!this.lifeSpan) {

  			this.apoptosis();
  		}
	}

	apoptosis() {

		this.manager.destroy(this);
	}

	draw () {

		fill(this.color);
		ellipse(this.x, this.y, this.r, this.r);
	}
}