import {Manager} from "./manager.js"
import {Circle} from "./circle.js"
import {Vector} from "./vector"
import {Point} from "./point.js"
import {getRandomInt} from "./utils"

var objects = [];
var vectors = [];

window.setup = () => {

	this.height = 800;
	this.width = 1500;

	angleMode(DEGREES);
	createCanvas(this.width, this.height);
	frameRate(120);

	let manager = new Manager(objects);

	for (let i=0; i <= this.width; i+=10) {

		for (let j=0; j <= this.height; j+=10) {

			let stroke = 1;
			if (i % 100 === 0 && j % 100 === 0) {
				stroke = 4;

			} else if (i % 50 === 0 && j % 50 === 0) {
				stroke = 2;
			}

			let point = new Point(i, j, stroke);
			objects.push(point);

			if (i % 25 === 0 && j % 25 === 0) {

				let vector = new Vector(point, getRandomInt(25, 50), getRandomInt(0, 90));
				vectors.push(vector);
			}
		}
	}

	for(let i=0; i < 100; i++) {

		let circle = new Circle(manager);
		objects.push(circle);	
	}

/*	let origin = new Point(100, 100)
	let arrow = new Arrow(origin, 250);
	objects.push(arrow)

	let origin2 = new Point(550, 22)
	let arrow2 = new Arrow(origin2, 26, 42);
	objects.push(arrow2)*/

	
}

window.draw = () => {

  clear();
  background(51);

  objects.forEach((object) => {

	object.update();
  	object.draw();
  });

    vectors.forEach((object) => {

	object.update();
  	object.draw();
  });
}
